﻿using System;
using System.Text;
using Infragistics.Win;
using System.Diagnostics;

namespace UltraWinValidator
{
    public class Condition : ICondition
    {
        private string valueToCheck;
        StringBuilder errMessageList;

        public Condition(string valueToCheck)
        {
            this.ValueToCheck = valueToCheck;
            errMessageList = new StringBuilder();
        }

        public string ValueToCheck
        {
            get { return this.valueToCheck; }
            set
            {
                this.valueToCheck = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged(this, new EventArgs());
                }
            }
        }

        public bool Matches(object value, IConditionContextProvider contextProvider)
        {
            // start with SP
            // longer than 5
            bool matchResult = true;
            errMessageList.Clear();
            if (value != null)
            {
                if (value.ToString().Length < 5)
                {
                    errMessageList.AppendLine("String must be longer than 5 ");
                    matchResult = matchResult && false;
                }

                if (!value.ToString().StartsWith("SP"))
                {
                    errMessageList.AppendLine("String must starts with 'SP'");
                    matchResult = matchResult && false;
                }

                return matchResult;
            }
            else
            {
                return false;
            }
        }

        public event EventHandler PropertyChanged;

        public override string ToString()
        {
            return errMessageList.ToString();
        }

        public object Clone()
        {
            Condition clonedCondition = new Condition(this.ValueToCheck);
            return clonedCondition;
        }
    }
}