﻿using System;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using System.Diagnostics;

namespace UltraWinValidator
{
    public partial class Form1 : Form
    {
        private const string EmptyFieldMessage = "This field is required!";

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ValidationSettings customValidation1 = ultraValidator1.GetValidationSettings(this.ultraTextEditor1);
            customValidation1.IsRequired = true;
            customValidation1.ValidationTrigger = ValidationTrigger.OnValidating;
            customValidation1.EmptyValueCriteria = EmptyValueCriteria.NullOrEmptyString;
            customValidation1.NotificationSettings.Text = EmptyFieldMessage;

            ValidationSettings customValidation2 = ultraValidator1.GetValidationSettings(this.ultraTextEditor2);
            customValidation2.IsRequired = true;
            customValidation2.ValidationTrigger = ValidationTrigger.OnValidating;
            customValidation2.EmptyValueCriteria = EmptyValueCriteria.NullOrEmptyString;
            customValidation2.NotificationSettings.Text = EmptyFieldMessage;

            Condition emptyCondition = new Condition("myCondition");
            customValidation1.Condition = emptyCondition;
            customValidation2.Condition = emptyCondition;
        }

        private void ultraValidator1_ValidationError(object sender, ValidationErrorEventArgs e)
        {
            if (e.Control != null)
            {
                for (int i = 0; i < e.Validation.Errors.Count; i++)
                {
                    ValidationResult error = e.Validation.Errors[i];
                    if (error.ValidationSettings.Condition is Condition && error.Status == ValidationStatus.ConditionFailure)
                    {
                        e.NotificationSettings.Text = e.Validation.Errors[i].ValidationSettings.Condition.ToString();
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Validation valid = this.ultraValidator1.Validate(true, false);

            
            if (!valid.IsValid)
            {
                for (int i = 0; i < valid.Errors.Count; i++)
                {
                    ValidationResult error = valid.Errors[i];
                    if (error.ValidationSettings.Condition is Condition && error.Status == ValidationStatus.ConditionFailure)
                    {
                        Debug.WriteLine(valid.Errors[i].ValidationSettings.Condition.ToString());
                        valid.Errors[i].ValidationSettings.NotificationSettings.Text = valid.Errors[i].ValidationSettings.Condition.ToString();
                        Debug.WriteLine(valid.Errors[i].ValidationSettings.NotificationSettings.Text);
                    }
                }

                MessageBox.Show("Please fill all fields correct");
                this.ultraValidator1.Validate(true, false);
            }
        }
    }
}
